import { LRParser } from '@lezer/lr';
import { LRLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "$hOVQPOOQhQPOOOOQO'#C_'#C_OsQPO'#CcOOQO'#Cf'#CfOVQPO'#ChO![QPO'#CjOOQO'#Cc'#CcOOQO'#C^'#C^OVQPO,58zOVQPO,58{OVQPO,58|O!aQPO,59QO!fQPO'#CiO!wQPO,59SOVQPO,59UOOQO1G.f1G.fO!|QPO1G.gO#bQPO1G.hOOQO1G.l1G.lOVQPO'#ClO#vQPO,59TOOQO1G.n1G.nO$OQPO1G.pO$TQPO,59WOOQO-E6j-E6jOOQO7+$[7+$[",
  stateData: "$f~OcOS~OWVOXROZSO_UOhTO~OdXOeYOfZO~Og[OaVXdVXeVXfVXiVXjVX~Oh_O~OXcO~OdXOeYOfZOidOj]X~OjfO~OdXOaTieTifTiiTijTi~OdXOeYOaUifUiiUijUi~OidOj]a~OjjO~OdXOeYOfZOi`aj`a~O",
  goto: "!naPPbu!O!O!OuPP!XP!X!b!XP!hQPOS]T_Q`XQaYQbZRhd_WOTXYZ_d_QOTXYZ_d_VOTXYZ_dQ^TRg_Qe]Rie",
  nodeNames: "⚠ Program Expression BinaryExpression Boolean Product Addition Scalar Number String MeasureReference MachineMeasureReference Parentheses Arguments FunctionCall Identifier",
  maxTerm: 26,
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: "*c~RkX^!vpq!vqr#krs#vxy$zyz%Pz{%U{|%Z|}%`}!O%Z!O!P%e!P!Q%U!Q![%j!^!_&T!_!`#k!`!a&T!c!}&]#T#o&]#o#p&h#y#z!v$f$g!v#BY#BZ!v$IS$I_!v$I|$JO!v$JT$JU!v$KV$KW!v&FU&FV!v~!{Yc~X^!vpq!v#y#z!v$f$g!v#BY#BZ!v$IS$I_!v$I|$JO!v$JT$JU!v$KV$KW!v&FU&FV!v~#nP!_!`#q~#vOd~~#yTOr$Ys#Q$Y#R;'S$Y;'S;=`$t<%lO$Y~$]UOr$Yrs$os#Q$Y#R;'S$Y;'S;=`$t<%lO$Y~$tOX~~$wP;=`<%l$Y~%POh~~%UOj~~%ZOe~~%`Of~~%eOi~~%jOg~~%oQW~!O!P%u!Q![%j~%xP!Q![%{~&QPW~!Q![%{~&YPd~!_!`#q~&bQ_~!c!}&]#T#o&]~&kP#o#p&n~&qP!o!p&t~&wP#X#Y&z~&}P#T#U'Q~'TP#g#h'W~'ZP#i#j'^~'aP#f#g'd~'gP#X#Y'j~'mP#p#q'p~'sPrs'v~'yTOr(Ys#Q(Y#R;'S(Y;'S;=`*]<%lO(Y~(]UOr(Yrs(os#Q(Y#R;'S(Y;'S;=`*]<%lO(Y~(rP!O!P(u~(xPrs({~)OTOr)_s#Q)_#R;'S)_;'S;=`*V<%lO)_~)bUOr)_rs)ts#Q)_#R;'S)_;'S;=`*V<%lO)_~)wP#q#r)z~)}P#q#r*Q~*VOZ~~*YP;=`<%l)_~*`P;=`<%l(Y",
  tokenizers: [0],
  topRules: {"Program":[0,1]},
  tokenPrec: 0
});

const nobieLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Application: delimitedIndent({ closing: ")", align: false }),
            }),
            foldNodeProp.add({
                Application: foldInside,
            }),
            styleTags({
                Number: tags.number,
                String: tags.string,
                Identifier: tags.variableName,
                Boolean: tags.bool,
                LineComment: tags.lineComment,
                "( )": tags.paren,
            }),
        ],
    }),
    languageData: {
        commentTokens: { line: ";" },
    },
});
function nobie() {
    return new LanguageSupport(nobieLanguage);
}

export { nobie, nobieLanguage };
